"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var PhRequest = /** @class */ (function () {
    function PhRequest() {
        /** Base url of endpoint */
        this.url = '';
        /** HTTP request method ( GET, POST, PUT ... ) */
        this.operation = 'GET';
        /** Query parameters */
        this.qs = {};
        /** Headers of the request */
        this.headers = {};
        /** form */
        this.form = {};
        /** The data to send with POST, PUT methods */
        this.data = '';
    }
    PhRequest.prototype.addJson = function (item) {
        this.headers['Content-Type'] = 'application/json';
        this.data = JSON.stringify(item);
    };
    PhRequest.prototype.request = function (page, onDone) {
        this.urlQuery = this.url;
        var query = this.encodeParams(this.qs);
        if (query !== '') {
            this.query = query;
            this.urlQuery += (this.url.indexOf('?') === -1 ? '?' : '&') + this.query;
        }
        var form = this.encodeParams(this.form);
        if (form !== '') {
            this.headers['Content-Type'] = 'application/x-www-form-urlencoded';
            this.data = form;
        }
        var code = 0;
        page.onLoadFinished = function () {
            page.onLoadFinished = function () { };
            onDone(page.plainText, code);
        };
        page.onResourceReceived = function (response) {
            code = response.status;
        };
        page.onResourceError = function (response) {
            code = parseInt(response.errorCode);
        };
        page.openUrl(this.urlQuery, this, {});
    };
    PhRequest.prototype.encodeParams = function (params) {
        var query = '';
        if (Object.keys(params).length > 0) {
            var cc = 0;
            for (var key in params) {
                if (cc > 0) {
                    query += '&';
                }
                query += encodeURIComponent(key) + '=' + encodeURIComponent(params[key]);
                cc++;
            }
        }
        return query;
    };
    Object.defineProperty(PhRequest.prototype, "method", {
        set: function (value) {
            this.operation = value;
        },
        enumerable: true,
        configurable: true
    });
    return PhRequest;
}());
exports.PhRequest = PhRequest;
function request(page, rq, onDone) {
    rq.request(page, onDone);
}
exports.request = request;
