export class PhRequest {
    /** Base url of endpoint */
    url:string = ''
    /** Base url of endpoint with query parameters */
    urlQuery : string
    /** HTTP request method ( GET, POST, PUT ... ) */
    operation: string = 'GET';
    /** Query parameters */
    qs : any = {}
    /** Headers of the request */
    headers: any = {}
    /** Generated string from the Query parameters */
    query: string
    /** form */
    form : any = {};
    /** The data to send with POST, PUT methods */
    data: string = '';

    addJson(item:any) : void {
        this.headers['Content-Type' ] = 'application/json';
        this.data = JSON.stringify(item);
    }

    request(page : any , onDone : (text:string,code:number) => void ) {
        this.urlQuery = this.url;
        let query    = this.encodeParams(this.qs);
        if ( query !== '' ) {
            this.query = query;
            this.urlQuery += (this.url.indexOf('?') === -1 ? '?' : '&') + this.query;
        }
        let form = this.encodeParams(this.form);
        if ( form !== '' ) {
            this.headers['Content-Type' ] = 'application/x-www-form-urlencoded';
            this.data = form;
        }
        let code : number = 0;
        page.onLoadFinished = function () {
            page.onLoadFinished = function() {};
            onDone(page.plainText, code)
        }
        page.onResourceReceived = function(response:any) {
            code = response.status;
        }
        page.onResourceError = function(response:any) {
            code = parseInt(response.errorCode);
        }
        page.openUrl( this.urlQuery, this , {});
    }

    encodeParams(params: any) : string {
        let query = '';
        if (Object.keys(params).length > 0) {
            let cc = 0;
            for (let key in params) {
                if (cc > 0) {
                    query += '&';
                }
                query += encodeURIComponent(key) + '=' + encodeURIComponent(params[key]);
                cc++;
            }
        }
        return query;
    }

    set method(value:string) {
        this.operation = value;
    }
}

export function request( page:any , rq:PhRequest , onDone : (text:string,code:number) => void) {
    rq.request(page,onDone);
}



